import { ConstType, ConstValue } from "../UPLCTerms/index.js";
import { UPLCTerm } from "./UPLCTerm.js";
import { UPLCVersion } from "../UPLCProgram/index.js";
type ParseUPLCTextEnv = {
    [x: string]: number;
};
export declare function _parseUPLCText(str: string, env: ParseUPLCTextEnv, dbn: number, version: UPLCVersion): {
    term: UPLCTerm;
    offset: number;
};
export declare function parseConstValueOfType(str: string, t: ConstType): {
    value: ConstValue;
    offset: number;
};
export declare function parseConstType(str: string): {
    type: ConstType;
    offset: number;
};
export declare function parseUPLCText(str: string, version?: UPLCVersion): UPLCTerm;
/**
 *
 * @param {string} str string removed of the first opening bracket
 * @example
 * ```ts
 * const str = "( hello )";
 * const expectedInput = str.slice(1); // " hello )";
 * const offset = getOffsetToNextClosingBracket( expectedInput ); // 8
 * ```
 * @returns
 */
export declare function getOffsetToNextClosingBracket(str: string, openCh?: "(" | "[", closeCh?: ")" | "]"): number;
export {};
