import { UPLCTerm } from "../UPLCTerm/UPLCTerm.js";
import { UPLCVar } from "./UPLCVar/index.js";
import { Lambda } from "./Lambda.js";
import { Builtin } from "./Builtin/Builtin.js";
import { Force } from "./Force.js";
import { BitStream } from "@harmoniclabs/bitstream";
export type UPLCApplicationBody = UPLCVar | Lambda | Application | Builtin | Force;
export declare function isUPLCApplicationBody(uplc: UPLCTerm): uplc is UPLCApplicationBody;
export declare class Application {
    static get UPLCTag(): BitStream;
    funcTerm: UPLCTerm;
    argTerm: UPLCTerm;
    constructor(func: UPLCTerm, arg: UPLCTerm);
    clone(): Application;
}
