export type UPLCBuiltinTagNumber = 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 | 26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 | 51 | 52 | 53;
/**
 * to encode as 7-bits
 */
export declare enum UPLCBuiltinTag {
    addInteger = 0,
    subtractInteger = 1,
    multiplyInteger = 2,
    divideInteger = 3,
    quotientInteger = 4,
    remainderInteger = 5,
    modInteger = 6,
    equalsInteger = 7,
    lessThanInteger = 8,
    lessThanEqualInteger = 9,
    appendByteString = 10,
    consByteString = 11,
    sliceByteString = 12,
    lengthOfByteString = 13,
    indexByteString = 14,
    equalsByteString = 15,
    lessThanByteString = 16,
    lessThanEqualsByteString = 17,
    sha2_256 = 18,
    sha3_256 = 19,
    blake2b_256 = 20,
    verifyEd25519Signature = 21,
    appendString = 22,
    equalsString = 23,
    encodeUtf8 = 24,
    decodeUtf8 = 25,
    ifThenElse = 26,
    chooseUnit = 27,
    trace = 28,
    fstPair = 29,
    sndPair = 30,
    chooseList = 31,
    mkCons = 32,
    headList = 33,
    tailList = 34,
    nullList = 35,
    chooseData = 36,
    constrData = 37,
    mapData = 38,
    listData = 39,
    iData = 40,
    bData = 41,
    unConstrData = 42,
    unMapData = 43,
    unListData = 44,
    unIData = 45,
    unBData = 46,
    equalsData = 47,
    mkPairData = 48,
    mkNilData = 49,
    mkNilPairData = 50,
    serialiseData = 51,
    verifyEcdsaSecp256k1Signature = 52,
    verifySchnorrSecp256k1Signature = 53,
    bls12_381_G1_add = 54,
    bls12_381_G1_neg = 55,
    bls12_381_G1_scalarMul = 56,
    bls12_381_G1_equal = 57,
    bls12_381_G1_hashToGroup = 58,
    bls12_381_G1_compress = 59,
    bls12_381_G1_uncompress = 60,
    bls12_381_G2_add = 61,
    bls12_381_G2_neg = 62,
    bls12_381_G2_scalarMul = 63,
    bls12_381_G2_equal = 64,
    bls12_381_G2_hashToGroup = 65,
    bls12_381_G2_compress = 66,
    bls12_381_G2_uncompress = 67,
    bls12_381_millerLoop = 68,
    bls12_381_mulMlResult = 69,
    bls12_381_finalVerify = 70,
    keccak_256 = 71,
    blake2b_224 = 72,
    integerToByteString = 73,
    byteStringToInteger = 74,
    andByteString = 75,
    orByteString = 76,
    xorByteString = 77,
    complementByteString = 78,
    readBit = 79,
    writeBits = 80,
    replicateByte = 81,
    shiftByteString = 82,
    rotateByteString = 83,
    countSetBits = 84,
    findFirstSetBit = 85,
    ripemd_160 = 86
}
export declare function isUPLCBuiltinTag(tag: UPLCBuiltinTag | UPLCBuiltinTagNumber): boolean;
export declare function getNRequiredForces(tag: UPLCBuiltinTag): (0 | 1 | 2);
export declare function isV1Supported(tag: UPLCBuiltinTag | UPLCBuiltinTagNumber): boolean;
export declare function isV2Supported(tag: UPLCBuiltinTag | UPLCBuiltinTagNumber): boolean;
export declare function builtinTagToString(tag: UPLCBuiltinTag): string;
export declare function builtinTagFromString(tag: string): UPLCBuiltinTag;
