"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UPLCVar = void 0;
var bitstream_1 = require("@harmoniclabs/bitstream");
var ints_1 = require("../../utils/ints.js");
var assert_1 = require("../../utils/assert.js");
var UPLCVar = /** @class */ (function () {
    function UPLCVar(deBruijn) {
        this._deBruijn = (0, ints_1.forceBigUInt)(deBruijn);
        (0, assert_1.assert)(this._deBruijn >= BigInt(0), "invalid deBruijn index; while creating 'UPLCVar' instance, deBruijn index was: "
            + this._deBruijn);
    }
    Object.defineProperty(UPLCVar, "UPLCTag", {
        get: function () {
            return bitstream_1.BitStream.fromBinStr("0000");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(UPLCVar.prototype, "deBruijn", {
        get: function () { return this._deBruijn; },
        enumerable: false,
        configurable: true
    });
    UPLCVar.prototype.clone = function () {
        return new UPLCVar(this.deBruijn);
    };
    return UPLCVar;
}());
exports.UPLCVar = UPLCVar;
